//==============================================================
// ̑̃c[ނ낢
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include "fvTool.h"
#include <psputility.h>
#include <psprtc.h>
#include <kubridge.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dialog.h"
#include "fvDraw.h"
#include "sound.h"
#include "unzip/FVunzip.h"
#include "FVunrar.h"

#define PF_BUFCNT	(5)											// vtFb`obt@̐
#define PF_BUFSIZE	(1024 * 16)									// vtFb`obt@̌X̃TCY

typedef struct {
	int		start;												// ̃obt@̊Jn|C^ʒu
	int		size;												// obt@̃TCYi0Ȃ疢gpj
	char	*data;
} strPrefetchBuf;												// vtFb`obt@\

struct {
	int				pfThread;									// Xbhnh
	int				mode;										// Xbhp
	int				load;										// ǂݏoҋ@p
	SceUID			fd;											// t@Cnh
	int				filePos;									// t@C|C^
	int				fileSize;									// t@CTCY
	SceInt64		ret;										// G[R[h
	int				readSize;
	strPrefetchBuf	buf[PF_BUFCNT];								// obt@
} gPfData;														// vtFb`Ǘ\

S_2CH			s2ch;


//==============================================================
// J[\ړ`FbN
//--------------------------------------------------------------

void cursorMove(int *pos, int count, int min)
{
	static int		keyStart = 0, keyRepeat = 0;
	static clock_t	keyTime = 0;
	static float	padStep = 0;
	int				padY, posBak;

	posBak = *pos;

	//----- pbhɂϗʈړ -----

	padY = s2ch.pad.Ly - 127;
	if (abs(padY) > s2ch.cfg.padCutoff) {
		padStep += ((padY > 0) - (padY < 0)) * (abs(padY) - s2ch.cfg.padCutoff) / 100.0;
		if (padStep > 1) {
			(*pos)++;
			padStep -= 1;
		} else if (padStep < -1) {
			(*pos)--;
			padStep += 1;
		}
	}

	//----- J[\L[ɂL[s[g -----

	if (s2ch.pad.Buttons != s2ch.oldPad.Buttons || keyRepeat) {
		if (s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
			keyStart = 1;
		} else {
			keyStart = 0;
		}
		keyTime = sceKernelLibcClock();
		keyRepeat = 0;
		if (s2ch.pad.Buttons & PSP_CTRL_UP) {
			(*pos)--;
		} 
		else if (s2ch.pad.Buttons & PSP_CTRL_DOWN) {
			(*pos)++;
		}

	} else {
		if (keyStart) {
			if (sceKernelLibcClock() - keyTime > 300000) {
				keyRepeat = 1;
			}
		} else {
			if (sceKernelLibcClock() - keyTime > 10000) {
				keyRepeat = 1;
			}
		}
	}

	//----- ͈͊O̕␳ -----

	if (*pos < min) {
		*pos = min;
	} else if (*pos >= count) {
		*pos = count - 1;
	}
	if (count == 0 && min == 0) *pos = 0;

	//----- J[\ړ -----

	if (posBak != *pos) {										// ړ
		sound_play( eSE_MOVE );
	}
}


//==============================================================
// t@C
//--------------------------------------------------------------

//===== t@C𕪊ēǂݍ =====
// BGM̉؂΍

SceInt64 fileDivRead(SceUID fd, void *data, SceSize size)
{
	SceInt64	ret, count;
	SceSize		readSize;

	count = 0;
	while (size) {
		readSize = 32 * 1024;
		if (size < readSize) readSize = size;
		ret = sceIoRead( fd, data, readSize );
		count += ret;
		data += ret;
		size -= ret;
		if (readSize != ret) break;
		DoEvent();
	}
	return count;
}

//===== t@C𕪊ď =====
// BGM̉؂΍

SceInt64 fileDivWrite(SceUID fd, const void *data, SceSize size, char *errMsg)
{
	SceInt64	ret, count;
	SceSize		writeSize;

	count = 0;
	while (size) {
		writeSize = 32 * 1024;
		if (size < writeSize) writeSize = size;
		ret = sceIoWrite( fd, data, writeSize );
		count += ret;
		data += ret;
		size -= ret;
		if (writeSize != ret) {
			if (errMsg) {
				MessageDialogText( "%s\nfile write failed", errMsg );
			}
			break;
		}
		DoEvent();
	}
	return count;
}

//===== t@C̃vtFb` =====
// V[PVANZXs鎖OƂt@C̐ǂݏB
// _ANZXłgpł͂邪APF_BUFSIZEȏɑOɑ傫ꍇ͌B
// Ô߃t@C|C^ʒüÕobt@͊{c悤ɂĂ܂B

//----- vtFb`Xbh -----

static int filePrefetchThread(SceSize args, void *argp)
{
	int			i, j, k, pos, delCount, filePos, rFlag, full;
	SceInt64	ret;

	while (gPfData.mode >= 0) {

		//--- vtFb`obt@̍폜 ---

		filePos = gPfData.filePos;
		delCount = PF_BUFCNT - 1;
		for (i = 0; i < PF_BUFCNT; i++) {						// }CiXŋĂ郂m폜
			if (gPfData.buf[i].size) {
				if ((filePos-PF_BUFSIZE*2) > gPfData.buf[i].start) {
					gPfData.buf[i].size = 0;					// |C^ȏÕm͍폜
				} else if ((filePos-PF_BUFSIZE) > gPfData.buf[i].start) {
					delCount--;									// |C^̈ÕmȂ
				}
			}
		}
		for (i = 0; i < PF_BUFCNT; i++) {						// vXŋĂ郂m폜
			if (gPfData.buf[i].size) {
				if ((filePos+PF_BUFSIZE*delCount) < gPfData.buf[i].start) {
					gPfData.buf[i].size = 0;
				}
			}
		}

		//--- vtFb`obt@ւ̓ǂݍ ---

		full = 0;
		for (i = 0; i < PF_BUFCNT; i++) {
			DoEvent();
			if (!gPfData.buf[i].size) {							// gpobt@Ȃ
				pos = filePos / PF_BUFSIZE * PF_BUFSIZE;
				for (j = 0; j < delCount; j++) {
					rFlag = 0;
					for (k = 0; k < PF_BUFCNT; k++) {			// filePos̓obt@ɓǂݍ܂Ă邩
						if (gPfData.buf[k].size && gPfData.buf[k].start==pos) {
							rFlag = 1;
							break;
						}
					}
					if (!rFlag) break;							// filePos`ǂݍ܂Ȃ΂ȂȂ
					pos += PF_BUFSIZE;
					if (pos > gPfData.fileSize) break;			// t@CTCY𒴂Ă
				}
				if (!rFlag && pos<gPfData.fileSize) {			// filePos`obt@ɓǂݍ
					full = 1;
					sceIoLseek32( gPfData.fd, pos, SEEK_SET );
					ret = sceIoRead( gPfData.fd, gPfData.buf[i].data, PF_BUFSIZE );
					if (ret < 0) {
						gPfData.ret = ret;
					} else {
						gPfData.ret = 0;
						gPfData.buf[i].start = pos;
						gPfData.buf[i].size = ret;
					}
					break;										// PǂނƂɃ|C^̊mFs
				}
			}
		}
		gPfData.load = 1;
		if (!full) {											// obt@tȂ
			while (gPfData.mode == 0) {							// |C^ω܂őҋ@
				sceKernelDelayThread( 100000 );
			}
			if (gPfData.mode >= 0) gPfData.mode = 0;			// -1:Iv
		}
	}

	gPfData.mode = 0;
	sceKernelExitThread( 0 );
	return 0;
}

//-----  -----

int filePrefetchInit(iniList *ini)
{
	char	*buf;
	int		i, err;

	gPfData.pfThread = sceKernelCreateThread( "Prefetch_thread", (SceKernelThreadEntry)&filePrefetchThread, 0x1F, 0x2000, 0, NULL );
	if (gPfData.pfThread < 0) {									// Xbh쐬oȂ
		sprintf( ini->msg[ini->phase], "vtFb`Xbh̍쐬Ɏs܂" );
		ini->error = -1;
		return -1;
	}

	err = 0;
	for (i = 0; i < PF_BUFCNT; i++) {
		buf = malloc( PF_BUFSIZE );
		gPfData.buf[i].data = buf;
		if (!buf) {
			err = 1;
		}
	}
	if (err) {													// mۂɎs
		for (i = 0; i < PF_BUFCNT; i++) {
			free( gPfData.buf[i].data );
		}
		sprintf( ini->msg[ini->phase], "vtFb`pobt@̊mۂɎs܂" );
		ini->error = -1;
		return -1;
	}
	return 0;
}

//----- t@CI[v -----

SceUID filePrefetchOpen(const char *file)
{
	int		i;
	SceUID	fd;

	for (i = 0; i < PF_BUFCNT; i++) {							// vtFb`obt@NA
		gPfData.buf[i].start = -1;
		gPfData.buf[i].size = 0;								// gpobt@
	}

	fd = sceIoOpen( file, PSP_O_RDONLY, FILE_PARMISSION );
	if (fd < 0) return fd;
	gPfData.fd = fd;
	gPfData.fileSize = sceIoLseek32( fd, 0, SEEK_END );
	sceIoLseek32( fd, 0, SEEK_SET );
	gPfData.filePos = 0;
	gPfData.ret = 0;
	gPfData.mode = 0;
	gPfData.load = 0;
	gPfData.readSize = 0;
	sceKernelStartThread( gPfData.pfThread, 0, NULL );
	return fd;
}

//----- V[N -----

int filePrefetchSeek(SceUID fd, int offset, int whence)
{
	int		fpos;

	fpos = gPfData.filePos;
	switch (whence) {
	case SEEK_SET:
		fpos = offset;
		break;
	case SEEK_CUR:
		fpos += offset;
		break;
	case SEEK_END:
		fpos = gPfData.fileSize + offset;
		break;
	}
	if (fpos < 0) fpos = 0;
	if (fpos > gPfData.fileSize) fpos = gPfData.fileSize;
	gPfData.filePos = fpos;

	gPfData.mode = 1;
	return gPfData.filePos;
}

//----- ǂݏo -----

SceInt64 filePrefetchRead(SceUID fd, void *data, SceSize size)
{
	int			i, pos, rFlag;
	SceSize		rSize;
	SceInt64	sum;

	sum = 0;
	do {
		do {
			rFlag = 0;
			if (size <= 0) break;								// ǂݍ݊
			for (i = 0; i < PF_BUFCNT; i++) {
				if (gPfData.buf[i].size) {						// Lȃobt@Ȃ
					pos = gPfData.filePos - gPfData.buf[i].start;
					if (pos>=0 && pos<gPfData.buf[i].size) {	// |C^ʒuɑΉĂobt@
						rSize = gPfData.buf[i].size - pos;
						if (rSize > size) rSize = size;
						memcpy( data, &gPfData.buf[i].data[pos], rSize );
						data += rSize;
						gPfData.filePos += rSize;
						gPfData.mode = 1;
						size -= rSize;
						sum += rSize;
						rFlag = 1;
						break;
					}
				}
			}
		} while (rFlag);
		if (size > 0) {											// obt@ɂ̓|C^ʒũf[^
			if (gPfData.ret) return gPfData.ret;				// G[Ă
			gPfData.mode = 1;									// vtFb`gCw
			while (gPfData.load == 0) {
				sceKernelDelayThread( 10000 );
			}
			gPfData.load = 0;
		}
	} while (size>0 && gPfData.filePos<gPfData.fileSize);

	gPfData.readSize = sum;
	return sum;
}

//----- N[Y -----

void filePrefetchClose(SceUID fd)
{
	gPfData.mode = -1;											// vtFb`XbhIv
	while ( gPfData.mode != 0 ) {								// vtFb`XbhI܂őҋ@
		sceKernelDelayThread( 10000 );
	}
	sceIoClose( gPfData.fd );
}

//----- I -----

void filePrefetchTerm()
{
	int		i;

	for (i = 0; i < PF_BUFCNT; i++) {
		free( gPfData.buf[i].data );
	}
	if (gPfData.pfThread > 0) {
		sceKernelDeleteThread( gPfData.pfThread );
	}
}

//----- mF -----

int filePrefetchVal()
{
	char	str[512], item[128];
	int		i;

	str[0] = '\0';
	for (i = 0; i < PF_BUFCNT; i++) {
		if (gPfData.buf[i].size) {
			sprintf( item, "%d : %d - %d %d\n", i, gPfData.buf[i].start, gPfData.buf[i].start+gPfData.buf[i].size,gPfData.buf[i].size );
		} else {
			sprintf( item, "%d : \n", i );
		}
		strcat( str, item );
	}

	sprintf( item, "\nreadPos : %d  readSize : %d  ret : %d", gPfData.filePos, gPfData.readSize, gPfData.ret );
	strcat( str, item );
	if_print( 5, 30, str, 0.6f, 0xFFFFFF, 0x101010, 1.0f );

	return 0;
}

//==============================================================
// obNXbh𓮂
//--------------------------------------------------------------

void DoEvent()
{
	static clock_t	dotime = 0;

	if (sceKernelLibcClock() - dotime > 8000) {					// 8ms
		dotime = sceKernelLibcClock();
		sceKernelDelayThread( 1000 );							// 1ms~đ̃Xbh𓮂
	}
}


//==============================================================
// w肳ꂽpXɑΉTlCt@C擾
//--------------------------------------------------------------
// file2 FTlCt@Cւ̃tpX
// file  Ft@Cւ̃tpX
// ߂lF 0 I
//         -1 pX擾łȂ
//--------------------------------------------------------------

int getThumbName(char *file2, char *file)
{
	char	*p;
	int		pos;

	p = strchr( file, ':' );
	if (p) {													// hCu^[Ȃ
		pos = p - file + 1;
		strncpy( file2, file, pos );
		file2[pos] = '/';
		file2[pos+1] = '\0';
		strcat( file2, THUMBFOLDER );							// TlCtH_
		strcat( file2, &file[pos] );							// TlCۑĂnỸtH_
		strcat( file2, ".dat" );								// TlCt@Cւ̃tpX
		return 0;
	} else {													// hCu^[Ȃi肦ȂnYj
		return -1;
	}
}


//==============================================================
// A[JCupX[hTlCt@C֕ۑ
//--------------------------------------------------------------

void writeArcPass(char *file, char *pass)
{
	SceUID			fd;
	unsigned short	buf[260];
	char			*p, path[1024], thFile[1024];
	int				len;

	len = strlen(pass);
	if (s2ch.cfg.arcPass && len>0 && len<256) {					// pX[hۑ
		if (getThumbName(thFile,file) == 0) {
			buf[0] = THUMBID | 0x0200;
			buf[1] = 0x5350;
			strcpy( (char*)&buf[2], pass );
			p = strrchr( thFile, '/' );
			if (p) {
				strncpy( path, thFile, p - thFile );
				path[p - thFile] = '\0';
				if (makedir(path)) {							// wtH_̐ɐ
					fd = sceIoOpen( thFile, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, FILE_PARMISSION );
					sceIoWrite( fd, buf, len + 4 );
					sceIoClose(fd);
				}
			}
		}
	}
}


//==============================================================
// A[JCupX[hTlCt@C擾
//--------------------------------------------------------------

void readArcPass(char *pass, char *file)
{
	SceUID			fd;
	unsigned short	buf[260];
	char			path[1024];
	int				size;

	*pass = '\0';
	if (getThumbName(path,file) == 0) {							// TlCt@CpX[h擾
		fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
		if (fd >= 0) {
			size = sceIoRead( fd, buf, sizeof(buf) );
			if (size > 4) {
				if (buf[0]==(THUMBID | 0x0200) && buf[1]==0x5350) {
					strncpy( pass, (char*)&buf[2], size - 4 );
					pass[size - 4] = '\0';
				}
			}
			sceIoClose(fd);
		}
	}
}


//==============================================================
// A[JCuɓWJ
//--------------------------------------------------------------
// sizeF  WJꂽf[^TCY
// ߂lFNULL G[
//         ȊO WJꂽf[^
//--------------------------------------------------------------
// mۂ郁͎ۂɕKvȗe+1bytemۂĂ܂B
//--------------------------------------------------------------

char *expandToMem(char *file, DirList *DList, int *size)
{
	char	*work, pass[256], msg[1024];
	int		ret;

	*size = 0;
	msg[0] = '\0';
	strcpy( pass, DList->archivePass );
	switch (DList->archiveType) {
	case 1:														// zipA[JCu
		ret = unzipToMemory( DList->archiveFile, &file[strlen(DList->archiveFile)+1], &work, pass, msg );
		if (ret == -3) {										// pX[hႤ
			if (pspOSKDialog("zipt@C̃pX[h", pass, 256, 1)!=2) {
				return NULL;									// LZꂽ
			}
			ret = unzipToMemory( DList->archiveFile, &file[strlen(DList->archiveFile)+1], &work, pass, msg );
			if (ret == -3) {									// ςpX[hႤ
				MessageDialogText( "%s\npX[hv܂", DList->archiveFile );
				return NULL;
			} else if (ret < 0) {								// pX[hȊÕG[
				MessageDialogText(msg);
				return NULL;
			}
			strcpy( DList->archivePass, pass );
			writeArcPass( DList->archiveFile, pass );			// pX[h̕ۑ
		} else if (ret < 0) {
			MessageDialogText(msg);
			return NULL;
		}
		break;
	case 2:														// rarA[JCu
		ret = unrarToMemory( DList->archiveFile, &file[strlen(DList->archiveFile)+1], &work, pass, msg );
		if (ret == -3) {										// pX[hႤ
			if (pspOSKDialog("rart@C̃pX[h", pass, 256, 1)!=2) {
				return NULL;									// LZꂽ
			}
			ret = unrarToMemory( DList->archiveFile, &file[strlen(DList->archiveFile)+1], &work, pass, msg );
			if (ret == -3) {									// ςpX[hႤ
				MessageDialogText( "%s\npX[hv܂", DList->archiveFile );
				return NULL;
			} else if (ret < 0) {								// pX[hȊÕG[
				MessageDialogText(msg);
				return NULL;
			}
			strcpy( DList->archivePass, pass );
			writeArcPass( DList->archiveFile, pass );			// pX[h̕ۑ
		} else if (ret < 0) {
			MessageDialogText(msg);
			return NULL;
		}
		break;
	default:
		return NULL;
	}
	*size = ret;

	return work;
}


//==============================================================
// t@C̊gq̔
//--------------------------------------------------------------
// ߂lF0 `9  摜t@C
//         10`29 t@C
//         30`49 t@C
//         50`89 eLXgt@C
//         90`98 A[JCut@C
//         99     gqȂ
//         100    ̑̃t@C
//--------------------------------------------------------------

int checkExt(char *path)
{
	char	*p;

	p = strrchr( path, '.' );
	if (p == NULL) return 99;

	if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0) {
		return EXT_TYPE_JPG;
	} else if (stricmp(p, ".png") == 0) {
		return EXT_TYPE_PNG;
	} else if (stricmp(p, ".gif") == 0) {
		return EXT_TYPE_GIF;
	} else if (stricmp(p, ".bmp") == 0) {
		return EXT_TYPE_BMP;
	} else if (stricmp(p, ".mp3") == 0) {
		return EXT_TYPE_MP3;
	} else if (stricmp(p, ".wav") == 0) {
		return EXT_TYPE_WAVE;
	} else if (stricmp(p, ".txt") == 0) {
		return EXT_TYPE_TXT;
	} else if (stricmp(p, ".ini") == 0) {
		return EXT_TYPE_INI;
	} else if (stricmp(p, ".cfg") == 0) {
		return EXT_TYPE_CFG;
	} else if (stricmp(p, ".zip") == 0) {
		return EXT_TYPE_ZIP;
	} else if (stricmp(p, ".rar") == 0) {
		return EXT_TYPE_RAR;
	}
	return 100;
}


//==============================================================
// t@CʂɑΉgq擾
//--------------------------------------------------------------

char *getExtName(int extType)
{
	switch (extType) {
	case EXT_TYPE_JPG:
		return ".jpg";
		break;
	case EXT_TYPE_PNG:
		return ".png";
		break;
	case EXT_TYPE_GIF:
		return ".gif";
		break;
	case EXT_TYPE_BMP:
		return ".bmp";
		break;
	case EXT_TYPE_MP3:
		return ".mp3";
		break;
	case EXT_TYPE_WAVE:
		return ".wav";
		break;
	case EXT_TYPE_TXT:
		return ".txt";
		break;
	case EXT_TYPE_INI:
		return ".ini";
		break;
	case EXT_TYPE_CFG:
		return ".cfg";
		break;
	case EXT_TYPE_ZIP:
		return ".zip";
		break;
	case EXT_TYPE_RAR:
		return ".rar";
		break;
	}
	return "";
}


//==============================================================
// ΉACRNo擾
//--------------------------------------------------------------

int getIconNo(char *path)
{
	int		type, icon;

	type = checkExt(path);
	icon = 2;
	if (type < EXT_TYPE_IMAGE) {								// 摜t@C
		icon = 3;
	} else if (type < EXT_TYPE_SOUND) {							// t@C
		icon = 4;
	} else if (type < EXT_TYPE_MOVIE) {							// t@C
		
	} else if (type < EXT_TYPE_TEXT) {							// eLXgt@C
		icon = 5;
	}
	return icon;
}


//==============================================================
// TlCpX擾
//--------------------------------------------------------------

void getThumbPath(char *thumbPath, char *path, char *name2)
{
	char	*p;
	int		pos;

	thumbPath[0] = '\0';
	pos = 0;
	p = strchr( path, ':' );
	if (p) {													// hCu^[Ȃ
		pos = p - path + 1;
		strncpy( thumbPath, path, pos );
		thumbPath[pos] = '/';
		thumbPath[pos+1] = '\0';
	}
	strcat( thumbPath, THUMBFOLDER );							// TlCtH_
	strcat( thumbPath, &path[pos] );
	if (name2) {
		strcat( thumbPath, "/" );
		strcat( thumbPath, name2 );
	}

}


